SHELL=/bin/sh

.SUFFIXES:
.SUFFIXES: .c .f .o

CC=cc
F77=f77
AR=ar cr

CFLAGS=-dalign -xO5
FFLAGS=-u -f -dalign -xO5
CFLAGSD=-dalign -g
FFLAGSD=-u -f -dalign -g


OBJDIR=./obj
DOBJDIR=./dobj
OUTDIR=../lib

OBJS= \
    $(OBJDIR)/missed.o \
    $(OBJDIR)/smexp.o \
    $(OBJDIR)/dmexp.o \
    $(OBJDIR)/cmexp.o \
    $(OBJDIR)/zmexp.o \
    $(OBJDIR)/npoly.o \
    $(OBJDIR)/spoly.o \
    $(OBJDIR)/dpoly.o \
    $(OBJDIR)/cpoly.o \
    $(OBJDIR)/zpoly.o \
    $(OBJDIR)/isamin.o \
    $(OBJDIR)/idamin.o \
    $(OBJDIR)/icamin.o \
    $(OBJDIR)/izamin.o \
    $(OBJDIR)/isamax.o \
    $(OBJDIR)/idamax.o \
    $(OBJDIR)/icamax.o \
    $(OBJDIR)/izamax.o \
    $(OBJDIR)/dcabs1.o

DOBJS= \
    $(DOBJDIR)/missed.o \
    $(DOBJDIR)/smexp.o \
    $(DOBJDIR)/dmexp.o \
    $(DOBJDIR)/cmexp.o \
    $(DOBJDIR)/zmexp.o \
    $(DOBJDIR)/npoly.o \
    $(DOBJDIR)/spoly.o \
    $(DOBJDIR)/dpoly.o \
    $(DOBJDIR)/cpoly.o \
    $(DOBJDIR)/zpoly.o \
    $(DOBJDIR)/isamin.o \
    $(DOBJDIR)/idamin.o \
    $(DOBJDIR)/icamin.o \
    $(DOBJDIR)/izamin.o \
    $(DOBJDIR)/isamax.o \
    $(DOBJDIR)/idamax.o \
    $(DOBJDIR)/icamax.o \
    $(DOBJDIR)/izamax.o \
    $(DOBJDIR)/dcabs1.o


all : libftn.a libftn_debug.a

debug : libftn_debug.a

libftn.a : $(OBJS)
	$(AR) $@ $(OBJS)
	ranlib $@
	mv $@ $(OUTDIR)

libftn_debug.a : $(DOBJS)
	$(AR) $@ $(DOBJS)
	ranlib $@
	mv $@ $(OUTDIR)

$(OBJDIR)/%.o: %.c
	@if [ ! -d $(OBJDIR) ]; then mkdir $(OBJDIR); fi
	$(CC) $(CFLAGS) -c -o $@ $<

$(DOBJDIR)/%.o: %.c
	@if [ ! -d $(DOBJDIR) ]; then mkdir $(DOBJDIR); fi
	$(CC) $(CFLAGSD) -c -o $@ $<

$(OBJDIR)/%.o: %.f
	$(F77) $(FFLAGS) -c -o $@ $<

$(DOBJDIR)/%.o: %.f
	$(F77) $(FFLAGSD) -c -o $@ $<

clean:
	rm $(OBJS) $(DOBJS)

cleanall:
	rm $(OBJS) $(DOBJS) $(OUTDIR)/libftn.a $(OUTDIR)/libftn_debug.a
