SHELL=/bin/sh

.SUFFIXES:
.SUFFIXES: .cpp .o
CC=g++

CFLAGS=-Wall -O -Wno-deprecated
CFLAGSD=-Wall -g -DDEBUG -Wno-deprecated
#CFLAGSD=-Wall -g -DDEBUG -Wno-deprecated -DCVM_FLOAT

# replace flags located above with the following ones if you want to use STLport
#CFLAGS=-Wall -I/usr/include/stlport -lstlport_gcc
#CFLAGSD=-Wall -g -DDEBUG -I/usr/include/stlport -lstlport_gcc

# replace flags located above with the following ones if you want to use STLport
#CFLAGS=-Wall -I/usr/include/stlport -lstlport_cygwin
#CFLAGSD=-Wall -g -DDEBUG -I/usr/include/stlport -lstlport_cygwin_stldebug


# it is assumed that you already have BLAS & LAPACK packages installed
LAPACK_BLAS_OPT=-llapack -lblas

# alternatively you can purchase or evaluate Intel MKL 7.2 library:
INTEL_MKL_PATH=/opt/intel/mkl72/lib/32
INTEL_MKL_OPT=-lmkl_lapack -lmkl_ia32 -lguide

CVM_LIB_PATH=../lib






lapack :
	$(CC) test.cpp -static -o regtest $(CFLAGS) -L$(CVM_LIB_PATH) -lcvm -lftn $(LAPACK_BLAS_OPT) -lg2c -lstdc++ -lpthread

lapack_debug :
	$(CC) test.cpp -static -o regtest $(CFLAGSD) -L$(CVM_LIB_PATH) -lcvm_debug -lftn_debug $(LAPACK_BLAS_OPT) -lstdc++ -lpthread -lg2c

lapack_cygwin :
	$(CC) test.cpp -static -o regtest $(CFLAGS) -L$(CVM_LIB_PATH) -lcvm -lftn $(LAPACK_BLAS_OPT) -lstdc++ -lg2c

lapack_debug_cygwin :
	$(CC) test.cpp -static -o regtest $(CFLAGSD) -L$(CVM_LIB_PATH) -lcvm_debug -lftn_debug $(LAPACK_BLAS_OPT) -lstdc++ -lg2c


mkl:
	$(CC) test.cpp -static -o regtest $(CFLAGS) -L$(CVM_LIB_PATH) -L$(INTEL_MKL_PATH) -lcvm -lftn_mkl $(INTEL_MKL_OPT) -lg2c -lstdc++ -lpthread -lpthread_nonshared

mkl_debug:
	$(CC) test.cpp -static -o regtest $(CFLAGSD) -L$(CVM_LIB_PATH) -L$(INTEL_MKL_PATH) -lcvm_debug -lftn_mkl_debug $(INTEL_MKL_OPT) -lg2c -lstdc++ -lpthread -lpthread_nonshared


lapack_so :
	$(CC) test.cpp -o regtest $(CFLAGS) -L$(CVM_LIB_PATH) -lcvm $(LAPACK_BLAS_OPT) -lg2c -lstdc++ -lpthread

lapack_so_debug :
	$(CC) test.cpp -o regtest $(CFLAGSD) -L$(CVM_LIB_PATH) -lcvm_debug $(LAPACK_BLAS_OPT) -lg2c -lstdc++ -lpthread

mkl_so:
	$(CC) test.cpp -o regtest $(CFLAGS) -L$(CVM_LIB_PATH) -L$(INTEL_MKL_PATH) -lcvm_mkl $(INTEL_MKL_OPT) -lg2c -lstdc++ -lpthread -lpthread_nonshared

mkl_so_debug:
	$(CC) test.cpp -o regtest $(CFLAGSD) -L$(CVM_LIB_PATH) -L$(INTEL_MKL_PATH) -lcvm_mkl_debug $(INTEL_MKL_OPT) -lg2c -lstdc++ -lpthread -lpthread_nonshared


clean:
	@-rm regtest test.o

