SHELL=/bin/sh

.SUFFIXES:
.SUFFIXES: .cpp .o

CC=CC
#AR=ar cr
AR=CC -xar -o

CFLAGS=-mt -dalign -xO5 -D_RWSTD_MULTI_THREAD -DTHREAD=MULTI
CFLAGSD=-mt -dalign -D_RWSTD_MULTI_THREAD -DTHREAD=MULTI -g -DDEBUG 


OBJDIR=./obj
DOBJDIR=./dobj
OUTDIR=../lib


OBJS= \
    $(OBJDIR)/globals.o \
    $(OBJDIR)/utils.o \
    $(OBJDIR)/arrays.o \
    $(OBJDIR)/cmatrix.o \
    $(OBJDIR)/cvector.o \
    $(OBJDIR)/rmatrix.o \
    $(OBJDIR)/rvector.o \
    $(OBJDIR)/scmatrix.o \
    $(OBJDIR)/srmatrix.o

DOBJS= \
    $(DOBJDIR)/globals.o \
    $(DOBJDIR)/utils.o \
    $(DOBJDIR)/arrays.o \
    $(DOBJDIR)/cmatrix.o \
    $(DOBJDIR)/cvector.o \
    $(DOBJDIR)/rmatrix.o \
    $(DOBJDIR)/rvector.o \
    $(DOBJDIR)/scmatrix.o \
    $(DOBJDIR)/srmatrix.o

all : libcvm.a libcvm_debug.a

release : libcvm.a

debug : libcvm_debug.a



libcvm.a : $(OBJS)
	$(AR) $@ $(OBJS)
	ranlib $@
	mv $@ $(OUTDIR)

libcvm_debug.a : $(DOBJS)
	$(AR) $@ $(DOBJS)
	ranlib $@
	mv $@ $(OUTDIR)

$(OBJDIR)/%.o: %.cpp cvm.h
	@if [ ! -d $(OBJDIR) ]; then mkdir $(OBJDIR); fi
	$(CC) $(CFLAGS) -c -o $@ $<

$(DOBJDIR)/%.o: %.cpp cvm.h
	@if [ ! -d $(DOBJDIR) ]; then mkdir $(DOBJDIR); fi
	$(CC) $(CFLAGSD) -c -o $@ $<


clean:
	rm -rf $(OBJS) $(DOBJS)

cleanall:
	rm -rf $(OBJS) $(DOBJS) $(OUTDIR)/libcvm.a $(OUTDIR)/libcvm_debug.a
